
HealPointsSpells = {
  SPELLTABLE = { };
};

local rankCache = { };

function HealPointsSpells:init()
	local _, className = UnitClass("player");
	if (className == "PALADIN") then
    self.SPELLTABLE[1] = {	
                { name = HPC_SPELL_FOL, type = 'normal', rank = 1, abbr = "FoL", avg = 67, time = 1.5, mana = 35, level = 20, bolfactor = 1},
                { name = HPC_SPELL_FOL, type = 'normal', rank = 2, abbr = "FoL", avg = 103, time = 1.5, mana = 50, level = 26, bolfactor = 1},
                { name = HPC_SPELL_FOL, type = 'normal', rank = 3, abbr = "FoL", avg = 154, time = 1.5, mana = 70, level = 34, bolfactor = 1},
                { name = HPC_SPELL_FOL, type = 'normal', rank = 4, abbr = "FoL", avg = 209, time = 1.5, mana = 90, level = 42, bolfactor = 1},
                { name = HPC_SPELL_FOL, type = 'normal', rank = 5, abbr = "FoL", avg = 283, time = 1.5, mana = 115, level = 50, bolfactor = 1},
                { name = HPC_SPELL_FOL, type = 'normal', rank = 6, abbr = "FoL", avg = 363, time = 1.5, mana = 140, level = 58, bolfactor = 1},
                { name = HPC_SPELL_FOL, type = 'normal', rank = 7, abbr = "FoL", avg = 475, time = 1.5, mana = 180, level = 66, bolfactor = 1}};
    self.SPELLTABLE[2] = {	
                { name = HPC_SPELL_HL, type = 'normal', rank = 1, abbr = "HL", avg = 43, time = 2.5, mana = 35, level = 1, bolfactor = 0.2},
                { name = HPC_SPELL_HL, type = 'normal', rank = 2, abbr = "HL", avg = 83, time = 2.5, mana = 60, level = 6, bolfactor = 0.4},
                { name = HPC_SPELL_HL, type = 'normal', rank = 3, abbr = "HL", avg = 173, time = 2.5, mana = 110, level = 14, bolfactor = 0.7},
                { name = HPC_SPELL_HL, type = 'normal', rank = 4, abbr = "HL", avg = 333, time = 2.5, mana = 190, level = 22, bolfactor = 1},
                { name = HPC_SPELL_HL, type = 'normal', rank = 5, abbr = "HL", avg = 522, time = 2.5, mana = 275, level = 30, bolfactor = 1},
                { name = HPC_SPELL_HL, type = 'normal', rank = 6, abbr = "HL", avg = 739, time = 2.5, mana = 365, level = 38, bolfactor = 1},
                { name = HPC_SPELL_HL, type = 'normal', rank = 7, abbr = "HL", avg = 999, time = 2.5, mana = 465, level = 46, bolfactor = 1},
                { name = HPC_SPELL_HL, type = 'normal', rank = 8, abbr = "HL", avg = 1317, time = 2.5, mana = 580, level = 54, bolfactor = 1},
                { name = HPC_SPELL_HL, type = 'normal', rank = 9, abbr = "HL", avg = 1680, time = 2.5, mana = 660, level = 60, bolfactor = 1},
                { name = HPC_SPELL_HL, type = 'normal', rank = 10, abbr = "HL", avg = 1840, time = 2.5, mana = 660, level = 62, bolfactor = 1},
                { name = HPC_SPELL_HL, type = 'normal', rank = 11, abbr = "HL", avg = 2321, time = 2.5, mana = 660, level = 70, bolfactor = 1}};
    self.SPELLTABLE[3] = { 
                { name = HPC_SPELL_HS, type = 'instant', rank = 1, abbr = "HS", avg = 212, time = 30, mana = 220, level = 40},
                { name = HPC_SPELL_HS, type = 'instant', rank = 2, abbr = "HS", avg = 290, time = 30, mana = 275, level = 48},
                { name = HPC_SPELL_HS, type = 'instant', rank = 3, abbr = "HS", avg = 380, time = 30, mana = 325, level = 56},
                { name = HPC_SPELL_HS, type = 'instant', rank = 4, abbr = "HS", avg = 470, time = 30, mana = 325, level = 64},
                { name = HPC_SPELL_HS, type = 'instant', rank = 5, abbr = "HS", avg = 552, time = 30, mana = 325, level = 70}};
                
	elseif (className == "PRIEST") then
    self.SPELLTABLE[1] = {	
                { name = HPC_SPELL_FH, type = 'normal', rank = 1, abbr = "FH", avg = 215, time = 1.5, mana = 125, level = 20},
                { name = HPC_SPELL_FH, type = 'normal', rank = 2, abbr = "FH", avg = 286, time = 1.5, mana = 155, level = 26},
                { name = HPC_SPELL_FH, type = 'normal', rank = 3, abbr = "FH", avg = 360, time = 1.5, mana = 185, level = 32},
                { name = HPC_SPELL_FH, type = 'normal', rank = 4, abbr = "FH", avg = 439, time = 1.5, mana = 215, level = 38},
                { name = HPC_SPELL_FH, type = 'normal', rank = 5, abbr = "FH", avg = 567, time = 1.5, mana = 265, level = 44},
                { name = HPC_SPELL_FH, type = 'normal', rank = 6, abbr = "FH", avg = 704, time = 1.5, mana = 315, level = 50},
                { name = HPC_SPELL_FH, type = 'normal', rank = 7, abbr = "FH", avg = 885, time = 1.5, mana = 380, level = 56},
                { name = HPC_SPELL_FH, type = 'normal', rank = 8, abbr = "FH", avg = 986, time = 1.5, mana = 380, level = 61},
                { name = HPC_SPELL_FH, type = 'normal', rank = 9, abbr = "FH", avg = 1190, time = 1.5, mana = 380, level = 67}};
    self.SPELLTABLE[2] = {	
                { name = HPC_SPELL_LH, type = 'normal', rank = 1, abbr = "LH", avg = 53, time = 1.5, mana = 30, level = 1},
                { name = HPC_SPELL_LH, type = 'normal', rank = 2, abbr = "LH", avg = 84, time = 2.0, mana = 45, level = 4},
                { name = HPC_SPELL_LH, type = 'normal', rank = 3, abbr = "LH", avg = 154, time = 2.5, mana = 75, level = 10},
                { name = HPC_SPELL_HEAL, type = 'normal', rank = 1, abbr = "Heal", avg = 330, time = 3.0, mana = 155, level = 16},
                { name = HPC_SPELL_HEAL, type = 'normal', rank = 2, abbr = "Heal", avg = 476, time = 3.0, mana = 205, level = 22},
                { name = HPC_SPELL_HEAL, type = 'normal', rank = 3, abbr = "Heal", avg = 624, time = 3.0, mana = 255, level = 28},
                { name = HPC_SPELL_HEAL, type = 'normal', rank = 4, abbr = "Heal", avg = 781, time = 3.0, mana = 305, level = 34},
                { name = HPC_SPELL_GH, type = 'normal', rank = 1, abbr = "GH", avg = 967, time = 3.0, mana = 370, level = 40},
                { name = HPC_SPELL_GH, type = 'normal', rank = 2, abbr = "GH", avg = 1248, time = 3.0, mana = 455, level = 46},
                { name = HPC_SPELL_GH, type = 'normal', rank = 3, abbr = "GH", avg = 1556, time = 3.0, mana = 545, level = 52},
                { name = HPC_SPELL_GH, type = 'normal', rank = 4, abbr = "GH", avg = 1917, time = 3.0, mana = 655, level = 58},
                { name = HPC_SPELL_GH, type = 'normal', rank = 5, abbr = "GH", avg = 2080, time = 3.0, mana = 710, level = 60},
                { name = HPC_SPELL_GH, type = 'normal', rank = 6, abbr = "GH", avg = 2242, time = 3.0, mana = 710, level = 63},
                { name = HPC_SPELL_GH, type = 'normal', rank = 7, abbr = "GH", avg = 2590, time = 3.0, mana = 710, level = 68}};
    self.SPELLTABLE[3] = {	
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 1, abbr = "Renew", avg = 45, duration = 15, mana = 30, level = 8},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 2, abbr = "Renew", avg = 100, duration = 15, mana = 65, level = 14},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 3, abbr = "Renew", avg = 175, duration = 15, mana = 105, level = 20},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 4, abbr = "Renew", avg = 245, duration = 15, mana = 140, level = 26},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 5, abbr = "Renew", avg = 315, duration = 15, mana = 170, level = 32},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 6, abbr = "Renew", avg = 400, duration = 15, mana = 205, level = 38},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 7, abbr = "Renew", avg = 510, duration = 15, mana = 250, level = 44},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 8, abbr = "Renew", avg = 650, duration = 15, mana = 305, level = 50},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 9, abbr = "Renew", avg = 810, duration = 15, mana = 365, level = 56},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 10, abbr = "Renew", avg = 970, duration = 15, mana = 410, level = 60},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 11, abbr = "Renew", avg = 1010, duration = 15, mana = 430, level = 65},
                { name = HPC_SPELL_RENEW, type = 'hot', rank = 12, abbr = "Renew", avg = 1110, duration = 15, mana = 450, level = 70}};

  elseif (className == "DRUID") then
    self.SPELLTABLE[1] = {	
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 1, abbr = "Regr", avg = 100, time = 2, mana = 100, hotavg = 98, duration = 21, level = 12},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 2, abbr = "Regr", avg = 176, time = 2, mana = 170, hotavg = 175, duration = 21, level = 18},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 3, abbr = "Regr", avg = 257, time = 2, mana = 230, hotavg = 259, duration = 21, level = 24},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 4, abbr = "Regr", avg = 339, time = 2, mana = 285, hotavg = 343, duration = 21, level = 30},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 5, abbr = "Regr", avg = 431, time = 2, mana = 345, hotavg = 427, duration = 21, level = 36},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 6, abbr = "Regr", avg = 543, time = 2, mana = 420, hotavg = 546, duration = 21, level = 42},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 7, abbr = "Regr", avg = 685, time = 2, mana = 505, hotavg = 686, duration = 21, level = 48},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 8, abbr = "Regr", avg = 857, time = 2, mana = 605, hotavg = 861, duration = 21, level = 54},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 9, abbr = "Regr", avg = 1061, time = 2, mana = 720, hotavg = 1064, duration = 21, level = 60},
                { name = HPC_SPELL_LIFEBL, type = 'lifebloom', rank = 1, abbr = "LifeBl", avg = 600, duration = 7, hotavg = 273, mana = 220, level = 64},
                { name = HPC_SPELL_REGR, type = 'regrowth', rank = 10, abbr = "Regr", avg = 1285, time = 2, mana = 845, hotavg = 1274, duration = 21, level = 65}}; 
    self.SPELLTABLE[2] = { 	
                { name = HPC_SPELL_HT, type = 'normal', rank = 1, abbr = "HT", avg = 44, time = 1.5, mana = 25, level = 1},
                { name = HPC_SPELL_HT, type = 'normal', rank = 2, abbr = "HT", avg = 100, time = 2.0, mana = 55, level = 8},
                { name = HPC_SPELL_HT, type = 'normal', rank = 3, abbr = "HT", avg = 219, time = 2.5, mana = 110, level = 14},
                { name = HPC_SPELL_HT, type = 'normal', rank = 4, abbr = "HT", avg = 404, time = 3.0, mana = 185, level = 20},
                { name = HPC_SPELL_HT, type = 'normal', rank = 5, abbr = "HT", avg = 633, time = 3.5, mana = 270, level = 26},
                { name = HPC_SPELL_HT, type = 'normal', rank = 6, abbr = "HT", avg = 818, time = 3.5, mana = 335, level = 32},
                { name = HPC_SPELL_HT, type = 'normal', rank = 7, abbr = "HT", avg = 1028, time = 3.5, mana = 405, level = 38},
                { name = HPC_SPELL_HT, type = 'normal', rank = 8, abbr = "HT", avg = 1313, time = 3.5, mana = 495, level = 44},
                { name = HPC_SPELL_HT, type = 'normal', rank = 9, abbr = "HT", avg = 1656, time = 3.5, mana = 600, level = 50},
                { name = HPC_SPELL_HT, type = 'normal', rank = 10, abbr = "HT", avg = 2060, time = 3.5, mana = 720, level = 56},
                { name = HPC_SPELL_HT, type = 'normal', rank = 11, abbr = "HT", avg = 2472, time = 3.5, mana = 800, level = 60},
                { name = HPC_SPELL_HT, type = 'normal', rank = 12, abbr = "HT", avg = 2577, time = 3.5, mana = 820, level = 62},
                { name = HPC_SPELL_HT, type = 'normal', rank = 13, abbr = "HT", avg = 2952, time = 3.5, mana = 935, level = 69}};
    self.SPELLTABLE[3] = {		
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 1, abbr = "Rejuv", avg = 32, duration = 12, mana = 25, level = 4},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 2, abbr = "Rejuv", avg = 56, duration = 12, mana = 40, level = 10},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 3, abbr = "Rejuv", avg = 116, duration = 12, mana = 75, level = 16},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 4, abbr = "Rejuv", avg = 180, duration = 12, mana = 105, level = 22},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 5, abbr = "Rejuv", avg = 244, duration = 12, mana = 135, level = 28},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 6, abbr = "Rejuv", avg = 304, duration = 12, mana = 160, level = 34},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 7, abbr = "Rejuv", avg = 388, duration = 12, mana = 195, level = 40},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 8, abbr = "Rejuv", avg = 488, duration = 12, mana = 235, level = 46},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 9, abbr = "Rejuv", avg = 608, duration = 12, mana = 280, level = 52},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 10, abbr = "Rejuv", avg = 756, duration = 12, mana = 335, level = 58},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 11, abbr = "Rejuv", avg = 888, duration = 12, mana = 360, level = 60},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 12, abbr = "Rejuv", avg = 932, duration = 12, mana = 370, level = 63},
                { name = HPC_SPELL_REJUV, type = 'hot', rank = 13, abbr = "Rejuv", avg = 1060, duration = 12, mana = 360, level = 69}};

  elseif (className == "SHAMAN") then
    self.SPELLTABLE[1] = {	
                { name = HPC_SPELL_LHW, type = 'normal', rank = 1, abbr = "LHW", avg = 174, time = 1.5, mana = 105, level = 20},
                { name = HPC_SPELL_LHW, type = 'normal', rank = 2, abbr = "LHW", avg = 264, time = 1.5, mana = 145, level = 28},
                { name = HPC_SPELL_LHW, type = 'normal', rank = 3, abbr = "LHW", avg = 359, time = 1.5, mana = 185, level = 36},
                { name = HPC_SPELL_LHW, type = 'normal', rank = 4, abbr = "LHW", avg = 486, time = 1.5, mana = 235, level = 44},
                { name = HPC_SPELL_LHW, type = 'normal', rank = 5, abbr = "LHW", avg = 668, time = 1.5, mana = 305, level = 52},
                { name = HPC_SPELL_LHW, type = 'normal', rank = 6, abbr = "LHW", avg = 880, time = 1.5, mana = 380, level = 60},
                { name = HPC_SPELL_LHW, type = 'normal', rank = 7, abbr = "LHW", avg = 1112, time = 1.5, mana = 440, level = 66}};
    self.SPELLTABLE[2] = {	
                { name = HPC_SPELL_HW, type = 'normal', rank = 1, abbr = "HW", avg = 39, time = 1.5, mana = 25, level = 1},
                { name = HPC_SPELL_HW, type = 'normal', rank = 2, abbr = "HW", avg = 71, time = 2.0, mana = 45, level = 6},
                { name = HPC_SPELL_HW, type = 'normal', rank = 3, abbr = "HW", avg = 142, time = 2.5, mana = 80, level = 12},
                { name = HPC_SPELL_HW, type = 'normal', rank = 4, abbr = "HW", avg = 292, time = 3.0, mana = 155, level = 18},
                { name = HPC_SPELL_HW, type = 'normal', rank = 5, abbr = "HW", avg = 408, time = 3.0, mana = 200, level = 24},
                { name = HPC_SPELL_HW, type = 'normal', rank = 6, abbr = "HW", avg = 579, time = 3.0, mana = 265, level = 32},
                { name = HPC_SPELL_HW, type = 'normal', rank = 7, abbr = "HW", avg = 797, time = 3.0, mana = 340, level = 40},
                { name = HPC_SPELL_HW, type = 'normal', rank = 8, abbr = "HW", avg = 1092, time = 3.0, mana = 440, level = 48},
                { name = HPC_SPELL_HW, type = 'normal', rank = 9, abbr = "HW", avg = 1464, time = 3.0, mana = 560, level = 56},
                { name = HPC_SPELL_HW, type = 'normal', rank = 10, abbr = "HW", avg = 1735, time = 3.0, mana = 620, level = 60},
                { name = HPC_SPELL_HW, type = 'normal', rank = 11, abbr = "HW", avg = 1847, time = 3.0, mana = 655, level = 63},
                { name = HPC_SPELL_HW, type = 'normal', rank = 12, abbr = "HW", avg = 2285, time = 3.0, mana = 720, level = 70}};
    self.SPELLTABLE[3] = {  
                { name = HPC_SPELL_CHAIN, type = 'chain', rank = 1, abbr = "CH", avg = 344, time = 2.5, mana = 260, level = 40},
                { name = HPC_SPELL_CHAIN, type = 'chain', rank = 2, abbr = "CH", avg = 435, time = 2.5, mana = 315, level = 46},
                { name = HPC_SPELL_CHAIN, type = 'chain', rank = 3, abbr = "CH", avg = 590, time = 2.5, mana = 405, level = 54},
                { name = HPC_SPELL_CHAIN, type = 'chain', rank = 4, abbr = "CH", avg = 648, time = 2.5, mana = 435, level = 61},
                { name = HPC_SPELL_CHAIN, type = 'chain', rank = 5, abbr = "CH", avg = 884, time = 2.5, mana = 540, level = 68}};
	end
end

function HealPointsSpells:getSpell(spellName, rank)
	for t = 1, 3, 1 do
		for i = 1, table.getn(self.SPELLTABLE[t]), 1 do
			if (self.SPELLTABLE[t][i]['name'] == spellName and self.SPELLTABLE[t][i]['rank'] == rank) then
				return self.SPELLTABLE[t][i];
			end
		end
	end
end

function HealPointsSpells:spellsChanged()
  rankCache = { };
end

function HealPointsSpells:getHighestSpellRank(spellName)
  local function getRealRank(spellName)
    local totalSpellTabs = GetNumSpellTabs();
    local totalSpells = 0;
    for t = 1, totalSpellTabs do
      local _, _, _, numSpells = GetSpellTabInfo(t);
      totalSpells = totalSpells + numSpells;
    end

    local highestRank = 0;
    for t = 1, totalSpells do
      local nameSpell, rankSpell = GetSpellName(t, BOOKTYPE_SPELL);
      if (nameSpell == spellName) then
        local j, k = string.find(rankSpell, HPC_DIV_RANK.." ");
        if (j ~= nil) then
          highestRank = math.max(highestRank, string.sub(rankSpell, k));
        end
      end
    end
    return highestRank;
  end
  
  if (rankCache[spellName] == nil) then
    rankCache[spellName] = getRealRank(spellName);
  end
  return rankCache[spellName];  
end

function HealPointsSpells:getHighestKnownSpell(spellTable)
  if (spellTable ~= nil) then
    for i = table.getn(spellTable), 1, -1 do
      if (self:getHighestSpellRank(spellTable[i]['name']) == spellTable[i]['rank'] and spellTable[i]['type'] ~= 'lifebloom') then -- Bit of a hack
        return spellTable[i];
      end
    end
  end
  return nil;
end

function HealPointsSpells:getCastTime(spell)
  local castTime = spell['time'];

	local _, className = UnitClass("player");

	if (className == "PALADIN") then
		if (spell['name'] == HPC_SPELL_HL) then
			castTime = castTime - HealPointsBS:GetBonus('CASTINGHOLYLIGHT') / 10; -- 3 pc Freethinker bonus
		end

	elseif (className == "PRIEST") then
		if (spell['name'] == HPC_SPELL_HEAL or spell['name'] == HPC_SPELL_GH) then
			castTime = castTime - HealPointsUtil:getTalentRank(HPC_TALENT_DIVFUR) * 0.1; -- Reduced time for Heal/Greater Heal by 0.1 per rank
		end
		if (spell['name'] == HPC_SPELL_FH) then
			castTime = castTime - HealPointsBS:GetBonus('CASTINGFLASHHEAL') / 10; -- 3 pc Prophecy bonus
		end

	elseif (className == "DRUID") then
		if (spell['name'] == HPC_SPELL_HT) then
			castTime = castTime - HealPointsUtil:getTalentRank(HPC_TALENT_NATURA) * 0.1; -- Reduced time for Healing Touch by 0.1 per rank 
		  castTime = castTime - HealPointsBS:GetBonus('CASTINGHEALINGTOUCH') / 100; -- Idol of Health (find a more reliable way)
		end
    if (spell['name'] == HPC_SPELL_REGR) then
			castTime = castTime - HealPointsBS:GetBonus('CASTINGREGROWTH') / 10; -- 5 pc Stormrage bonus
		end

  elseif (className == "SHAMAN") then
		if (spell['name'] == HPC_SPELL_HW) then
			castTime = castTime - HealPointsUtil:getTalentRank(HPC_TALENT_IMHEWA) * 0.1; -- Reduced time for Healing Wave by 0.1 per rank
		end
		if (spell['name'] == HPC_SPELL_CHAIN) then
			castTime = castTime - HealPointsBS:GetBonus('CASTINGCHAINHEAL') / 10; -- 5 pc Stormcaller bonus
		end
  end
  
  return castTime;
end

function HealPointsSpells:getDuration(spell)
  local duration = spell['duration'];

	local _, className = UnitClass("player");

	if (className == "PRIEST") then
		if (spell['name'] == HPC_SPELL_RENEW) then
      duration = duration + HealPointsBS:GetBonus('DURATIONRENEW'); -- 5 pc Oracle bonus
		end

	elseif (className == "DRUID") then
		if (spell['name'] == HPC_SPELL_REJUV) then
      duration = duration + HealPointsBS:GetBonus('DURATIONREJUV'); -- 8 pc Stormrage bonus
		end
  end

  return duration;
end

function HealPointsSpells:getManaCost(spell, spellCrit)
  local percentCheaper = 0;
  local refund = 0;

  spellCrit = spellCrit + self:getSpellCritBonus(spell);

	local _, className = UnitClass("player");

  if (className == "PALADIN") then
    percentCheaper = (spellCrit / 100) * 0.20 * HealPointsUtil:getTalentRank(HPC_TALENT_ILLUMI); -- Reduced mana cost for crits by 20% per rank

  elseif (className == "PRIEST") then
		if (spell['name'] == HPC_SPELL_RENEW) then
      percentCheaper = HealPointsUtil:getTalentRank(HPC_TALENT_MENAGI) * 0.02; -- Reduced mana cost for Renew by 2% per rank
      percentCheaper = percentCheaper + HealPointsBS:GetBonus('CHEAPERRENEW') / 100; -- 2 pc Vestments of Faith bonus
		end
    if (spell['name'] == HPC_SPELL_LH or spell['name'] == HPC_SPELL_HEAL or spell['name'] == HPC_SPELL_GH) then
      percentCheaper = HealPointsUtil:getTalentRank(HPC_TALENT_IMPHEA) * 0.05; -- Reduced mana cost for slow heal by 5% per rank
		end

  elseif (className == "DRUID") then
    percentCheaper = HealPointsUtil:getTalentRank(HPC_TALENT_MOONGL) * 0.03;		-- Reduced mana cost for all spells by 3% per rank
    percentCheaper = percentCheaper + HealPointsBS:GetBonus('CHEAPERDRUID') / 100; -- 4 pc Dreamwalker bonus
    if (spell['name'] == HPC_SPELL_HT) then
      percentCheaper = percentCheaper + HealPointsUtil:getTalentRank(HPC_TALENT_TRASPI) * 0.02; -- Reduced mana cost for Healing Touch by 2% per rank
      refund = (spellCrit / 100) * 0.01 * HealPointsBS:GetBonus('REFUNDHTCRIT') * spell['mana']; -- 8 pc Dreamwalker bonus
      if (HealPointsBS:GetBonus('REFUNDHT') > 0) then
        refund = refund + math.min(HealPointsBS:GetBonus('REFUNDHT'), spell['mana'] / (HealPointsBS:GetBonus('REFUNDHT') - 1)); -- Idol of Longevity
      end
		end
    if (HealPointsUtil:isPlayerBuffUp(HPC_BUFF_TREELI) and (spell['name'] == HPC_SPELL_REJUV or spell['name'] == HPC_SPELL_REGR or spell['name'] == HPC_SPELL_LIFEBL)) then
      percentCheaper = percentCheaper + 0.2; -- 20% cheaper in treeform
    end

	elseif (className == "SHAMAN") then
    percentCheaper = HealPointsUtil:getTalentRank(HPC_TALENT_TIDFOC) * 0.01; -- Reduced mana cost for all spells by 1% per rank
    if (spell['name'] == HPC_SPELL_LHW or spell['name'] == HPC_SPELL_HW) then
      refund = 0.25 * 0.01 * HealPointsBS:GetBonus('REFUNDHEALINGWAVE') * spell['mana']; -- 5 pc Earthfury bonus
    end
  end
    
  return spell['mana'] * (1 - percentCheaper) - refund;
end

function HealPointsSpells:getSpellBonus(spell) 
  local percentBonus = 0;

	local _, className = UnitClass("player");

	if (className == "PALADIN") then
		if (spell['name'] == HPC_SPELL_FOL or spell['name'] == HPC_SPELL_HL) then
      percentBonus = HealPointsUtil:getTalentRank(HPC_TALENT_HEALIG) * 0.04; -- Increases avg for both spells by 4% per rank
		end

	elseif (className == "PRIEST") then
    percentBonus = HealPointsUtil:getTalentRank(HPC_TALENT_SPIHEA) * 0.02;  -- Increased avg for all spells by 2% per rank
    if (spell['name'] == HPC_SPELL_RENEW) then
      percentBonus = percentBonus + HealPointsUtil:getTalentRank(HPC_TALENT_IMPREN) * 0.05; -- Increased avg for Renew by 5% per rank
      percentBonus = percentBonus + HealPointsBS:GetBonus('DURATIONRENEW') / 15; -- From 5 tics to 6 tics => 20 % increase
		end

	elseif (className == "DRUID") then
		percentBonus = HealPointsUtil:getTalentRank(HPC_TALENT_GIOFNA) * 0.02;				-- Increased avg for all spells by 2% per rank
		if (spell['name'] == HPC_SPELL_REJUV) then
      percentBonus = percentBonus + HealPointsUtil:getTalentRank(HPC_TALENT_IMPREJ) * 0.05; -- Increased avg for Rejuvenation by 5% per rank
      percentBonus = percentBonus + HealPointsBS:GetBonus('DURATIONREJUV') / 12 -- From 4 tics to 5 tics => 25 % increase
		end

	elseif (className == "SHAMAN") then
    percentBonus = HealPointsUtil:getTalentRank(HPC_TALENT_PURIFI) * 0.02; -- Increased avg for all spells by 2% per rank
    if (spell['name'] == HPC_SPELL_CHAIN) then
      percentBonus = percentBonus + HealPointsUtil:getTalentRank(HPC_TALENT_IMPCHA) * 0.1; -- Increased avg for Chain heal by 10% per rank
    end
  end
    
  return percentBonus;
end

function HealPointsSpells:getHealingFactor(spell)
	local levelFactor = 1 - ((20 - math.min(20, spell['level'])) * 0.0375);
  levelFactor = levelFactor * math.min(1, (spell['level'] + 11) / UnitLevel("player"));

  local timeFactor, timeFactor2;
  if (spell['type'] == 'regrowth') then
    timeFactor = 0.5 * math.min(spell['time'], 3.5) / 3.5;
    timeFactor2 = 0.5 * spell['duration'] / 15; -- Now scales above 100%
  elseif (spell['type'] == 'lifebloom') then
    timeFactor = 1 / 1.9; -- Needs more testing?
    timeFactor2 = 1.5 / 3.5;
  elseif (spell['type'] == 'hot') then
    timeFactor = spell['duration'] / 15; --- Now scales above 100%
  elseif (spell['type'] == 'instant') then
    timeFactor = 1.5 / 3.5;
  else -- normal / chain
    timeFactor = math.min(spell['time'], 3.5) / 3.5;
	end
  
  -- Empowered talents (strange difference between empowered healing and empowered rejuvenation)
  if (spell['name'] == HPC_SPELL_GH) then
    timeFactor = timeFactor + HealPointsUtil:getTalentRank(HPC_TALENT_EMPHEA) * 0.04; -- +4% bonus healing per rank
  elseif (spell['name'] == HPC_SPELL_FH) then
    timeFactor = timeFactor + HealPointsUtil:getTalentRank(HPC_TALENT_EMPHEA) * 0.02; -- +2% bonus healing per rank
  elseif (spell['name'] == HPC_SPELL_HT) then
    timeFactor = timeFactor * (1 + HealPointsUtil:getTalentRank(HPC_TALENT_EMPOHT) * 0.1); -- +10% bonus healing per rank
  elseif (spell['name'] == HPC_SPELL_REJUV or spell['name'] == HPC_SPELL_REGR or spell['name'] == HPC_SPELL_LIFEBL) then
    timeFactor = timeFactor * (1 + HealPointsUtil:getTalentRank(HPC_TALENT_EMPREJ) * 0.04); -- +4% bonus healing per rank
    if (timeFactor2 ~= nil) then
      timeFactor2 = timeFactor2 * (1 + HealPointsUtil:getTalentRank(HPC_TALENT_EMPREJ) * 0.04); -- +4% bonus healing per rank
    end
  end
  
  if (timeFactor2 ~= nil) then
    return levelFactor * timeFactor, levelFactor * timeFactor2;
  else
    return levelFactor * timeFactor;
  end
end

function HealPointsSpells:getSpellCritBonus(spell)
  local critBonus = 0;
  
  if (spell['name'] == HPC_SPELL_REGR) then
    critBonus = 10 * HealPointsUtil:getTalentRank(HPC_TALENT_IMPREG); -- Increases crit for Regrowth by 10% per rank
  elseif (spell['name'] == HPC_SPELL_HL) then
    critBonus = 2 * HealPointsUtil:getTalentRank(HPC_TALENT_SANCLI); -- Increases crit for Holy Light by 2% per rank
  end
  
  return critBonus;
end

function HealPointsSpells:getHealingBonus(spell)
  local healBonus = 0;

  if (spell['name'] == HPC_SPELL_REJUV) then
    healBonus = HealPointsBS:GetBonus('IMPREJUVENATION'); -- Idol of Rejuvenation
  elseif (spell['name'] == HPC_SPELL_LHW) then
    healBonus = HealPointsBS:GetBonus('IMPLESSERHEALINGWAVE'); -- Totem of Life/Sustaining
  elseif (spell['name'] == HPC_SPELL_FOL) then
    healBonus = HealPointsBS:GetBonus('IMPFLASHOFLIGHT'); -- Libram of Grace/Divinity
  elseif (spell['name'] == HPC_SPELL_HT) then
    healBonus = HealPointsBS:GetBonus('IMPHEALINGTOUCH'); -- Idol of Health
  end
  
  return healBonus;
end
